#ifndef USER_INTERFACE
#define USER_INTERFACE

#include <iostream>
#include <string>
#include "script_tools.h"

using namespace std;

string get_xml_raw(uint32 max_input_size = 1048576);

void add_encoding_error(const string& error);
void add_parse_error(const string& error);
void add_static_error(const string& error);
void add_sanity_error(const string& error);

void add_encoding_remark(const string& error);
void add_parse_remark(const string& error);
void add_static_remark(const string& error);
void add_sanity_remark(const string& error);

int display_encoding_errors();
int display_parse_errors(const string& input);
int display_static_errors(const string& input);
int display_sanity_errors(const string& input);

void static_analysis(const string& input);

void display_verbatim(const string& text);
void display_state(const string& text);

void runtime_error(const string& error);
void runtime_remark(const string& error);

void statement_finished(const Statement* stmt);

const int MIXED_XML = 1;
const int HTML = 2;
const int NOTHING = 3;

void out_header(int type);

void out_footer(int type);

const int QUIET = 1;
const int ERRORS = 2;
const int VERBOSE = 3;
const int STATIC_ANALYSIS = 4;

void set_debug_mode(int mode);
int get_debug_mode();
void set_meta_db(string current_db_);

#endif
